diff --git a/taskcluster/taskgraph/transforms/tests/make_task_description.py b/taskcluster/taskgraph/transforms/tests/make_task_description.py
index fc3f948930..1e29558d6b 100644
--- a/taskcluster/taskgraph/transforms/tests/make_task_description.py
+++ b/taskcluster/taskgraph/transforms/tests/make_task_description.py
@@ -248,7 +248,7 @@ def docker_worker_setup(config, test, taskdesc):
         elif mozharness['chunking-args'] == 'test-suite-suffix':
             suffix = mozharness['chunk-suffix'].replace('<CHUNK>', str(test['this-chunk']))
             for i, c in enumerate(command):
-                if isinstance(c, basestring) and c.startswith('--test-suite'):
+                if isinstance(c, str) and c.startswith('--test-suite'):
                     command[i] += suffix
 
     if 'download-symbols' in mozharness:
@@ -352,7 +352,7 @@ def generic_worker_setup(config, test, taskdesc):
     mh_command.extend(['--installer-url', installer_url])
     mh_command.extend(['--test-packages-url', test_packages_url])
     if mozharness.get('download-symbols'):
-        if isinstance(mozharness['download-symbols'], basestring):
+        if isinstance(mozharness['download-symbols'], str):
             mh_command.extend(['--download-symbols', mozharness['download-symbols']])
         else:
             mh_command.extend(['--download-symbols', 'true'])
@@ -366,7 +366,7 @@ def generic_worker_setup(config, test, taskdesc):
         elif mozharness['chunking-args'] == 'test-suite-suffix':
             suffix = mozharness['chunk-suffix'].replace('<CHUNK>', str(test['this-chunk']))
             for i, c in enumerate(mh_command):
-                if isinstance(c, basestring) and c.startswith('--test-suite'):
+                if isinstance(c, str) and c.startswith('--test-suite'):
                     mh_command[i] += suffix
 
     worker['command'] = [
@@ -436,7 +436,7 @@ def macosx_engine_setup(config, test, taskdesc):
         elif mozharness['chunking-args'] == 'test-suite-suffix':
             suffix = mozharness['chunk-suffix'].replace('<CHUNK>', str(test['this-chunk']))
             for i, c in enumerate(command):
-                if isinstance(c, basestring) and c.startswith('--test-suite'):
+                if isinstance(c, str) and c.startswith('--test-suite'):
                     command[i] += suffix
 
     if 'download-symbols' in mozharness:
diff --git a/taskcluster/taskgraph/transforms/tests/test_description.py b/taskcluster/taskgraph/transforms/tests/test_description.py
index 1365919fe3..293802f612 100644
--- a/taskcluster/taskgraph/transforms/tests/test_description.py
+++ b/taskcluster/taskgraph/transforms/tests/test_description.py
@@ -29,37 +29,37 @@ from voluptuous import (
 # *****WARNING*****
 test_description_schema = Schema({
     # description of the suite, for the task metadata
-    'description': basestring,
+    'description': str,
 
     # test suite name, or <suite>/<flavor>
     Required('suite'): Any(
-        basestring,
-        {'by-test-platform': {basestring: basestring}},
+        str,
+        {'by-test-platform': {str: str}},
     ),
 
     # the name by which this test suite is addressed in try syntax; defaults to
     # the test-name
-    Optional('unittest-try-name'): basestring,
+    Optional('unittest-try-name'): str,
 
     # the symbol, or group(symbol), under which this task should appear in
     # treeherder.
-    'treeherder-symbol': basestring,
+    'treeherder-symbol': str,
 
     # the value to place in task.extra.treeherder.machine.platform; ideally
     # this is the same as build-platform, and that is the default, but in
     # practice it's not always a match.
-    Optional('treeherder-machine-platform'): basestring,
+    Optional('treeherder-machine-platform'): str,
 
     # attributes to appear in the resulting task (later transforms will add the
     # common attributes)
-    Optional('attributes'): {basestring: object},
+    Optional('attributes'): {str: object},
 
     # The `run_on_projects` attribute, defaulting to "all".  This dictates the
     # projects on which this task should be included in the target task set.
     # See the attributes documentation for details.
     Optional('run-on-projects', default=['all']): Any(
-        [basestring],
-        {'by-test-platform': {basestring: [basestring]}},
+        [str],
+        {'by-test-platform': {str: [str]}},
     ),
 
     # the sheriffing tier for this task (default: set based on test platform)
@@ -70,12 +70,12 @@ test_description_schema = Schema({
     # test platform is not found, the key 'default' will be tried.
     Required('chunks', default=1): Any(
         int,
-        {'by-test-platform': {basestring: int}},
+        {'by-test-platform': {str: int}},
     ),
 
     # the time (with unit) after which this task is deleted; default depends on
     # the branch (see below)
-    Optional('expires-after'): basestring,
+    Optional('expires-after'): str,
 
     # Whether to run this task with e10s (desktop-test only).  If false, run
     # without e10s; if true, run with e10s; if 'both', run one task with and
@@ -83,13 +83,13 @@ test_description_schema = Schema({
     # and treeherder group.
     Required('e10s', default='both'): Any(
         bool, 'both',
-        {'by-test-platform': {basestring: Any(bool, 'both')}},
+        {'by-test-platform': {str: Any(bool, 'both')}},
     ),
 
     # The EC2 instance size to run these tests on.
     Required('instance-size', default='default'): Any(
         Any('default', 'large', 'xlarge', 'legacy'),
-        {'by-test-platform': {basestring: Any('default', 'large', 'xlarge', 'legacy')}},
+        {'by-test-platform': {str: Any('default', 'large', 'xlarge', 'legacy')}},
     ),
 
     # Whether the task requires loopback audio or video (whatever that may mean
@@ -119,16 +119,16 @@ test_description_schema = Schema({
     # generally `desktop-test`, or an image that acts an awful lot like it.
     Required('docker-image', default={'in-tree': 'desktop-test'}): Any(
         # a raw Docker image path (repo/image:tag)
-        basestring,
+        str,
         # an in-tree generated docker image (from `testing/docker/<name>`)
-        {'in-tree': basestring}
+        {'in-tree': str}
     ),
 
     # seconds of runtime after which the task will be killed.  Like 'chunks',
     # this can be keyed by test pltaform.
     Required('max-run-time', default=3600): Any(
         int,
-        {'by-test-platform': {basestring: int}},
+        {'by-test-platform': {str: int}},
     ),
 
     # the exit status code that indicates the task should be retried
@@ -140,27 +140,27 @@ test_description_schema = Schema({
     # What to run
     Required('mozharness'): Any({
         # the mozharness script used to run this task
-        Required('script'): basestring,
+        Required('script'): str,
 
         # the config files required for the task
         Required('config'): Any(
-            [basestring],
-            {'by-test-platform': {basestring: [basestring]}},
+            [str],
+            {'by-test-platform': {str: [str]}},
         ),
 
         # any additional actions to pass to the mozharness command
-        Optional('actions'): [basestring],
+        Optional('actions'): [str],
 
         # additional command-line options for mozharness, beyond those
         # automatically added
         Required('extra-options', default=[]): Any(
-            [basestring],
-            {'by-test-platform': {basestring: [basestring]}},
+            [str],
+            {'by-test-platform': {str: [str]}},
         ),
 
         # the artifact name (including path) to test on the build task; this is
         # generally set in a per-kind transformation
-        Optional('build-artifact-name'): basestring,
+        Optional('build-artifact-name'): str,
 
         # If true, tooltool downloads will be enabled via relengAPIProxy.
         Required('tooltool-downloads', default=False): bool,
@@ -197,7 +197,7 @@ test_description_schema = Schema({
         # the string to append to the `--test-suite` arugment when
         # chunking-args = test-suite-suffix; "<CHUNK>" in this string will
         # be replaced with the chunk number.
-        Optional('chunk-suffix'): basestring,
+        Optional('chunk-suffix'): str,
     }),
 
     # The current chunk; this is filled in by `all_kinds.py`
@@ -206,24 +206,24 @@ test_description_schema = Schema({
     # os user groups for test task workers; required scopes, will be
     # added automatically
     Optional('os-groups', default=[]): Any(
-        [basestring],
+        [str],
         # todo: create a dedicated elevated worker group and name here
-        {'by-test-platform': {basestring: [basestring]}},
+        {'by-test-platform': {str: [str]}},
     ),
 
     # -- values supplied by the task-generation infrastructure
 
     # the platform of the build this task is testing
-    'build-platform': basestring,
+    'build-platform': str,
 
     # the label of the build task generating the materials to test
-    'build-label': basestring,
+    'build-label': str,
 
     # the platform on which the tests will run
-    'test-platform': basestring,
+    'test-platform': str,
 
     # the name of the test (the key in tests.yml)
-    'test-name': basestring,
+    'test-name': str,
 
 }, required=True)
 
diff --git a/taskcluster/taskgraph/try_option_syntax.py b/taskcluster/taskgraph/try_option_syntax.py
index b5988db981..609a7c0d23 100644
--- a/taskcluster/taskgraph/try_option_syntax.py
+++ b/taskcluster/taskgraph/try_option_syntax.py
@@ -259,8 +259,8 @@ class TryOptionSyntax(object):
     def parse_build_types(self, build_types_arg):
         if build_types_arg is None:
             build_types_arg = []
-        build_types = filter(None, [BUILD_TYPE_ALIASES.get(build_type) for
-                             build_type in build_types_arg])
+        build_types = [_f for _f in [BUILD_TYPE_ALIASES.get(build_type) for
+                             build_type in build_types_arg] if _f]
         return build_types
 
     def parse_platforms(self, platform_arg):
@@ -294,7 +294,7 @@ class TryOptionSyntax(object):
             return []
 
         all_platforms = set(t.attributes['test_platform']
-                            for t in full_task_graph.tasks.itervalues()
+                            for t in full_task_graph.tasks.values()
                             if 'test_platform' in t.attributes)
 
         tests = self.parse_test_opts(test_arg, all_platforms)
@@ -303,7 +303,7 @@ class TryOptionSyntax(object):
             return []
 
         all_tests = set(t.attributes[attr_name]
-                        for t in full_task_graph.tasks.itervalues()
+                        for t in full_task_graph.tasks.values()
                         if attr_name in t.attributes)
 
         # Special case where tests is 'all' and must be expanded
@@ -455,12 +455,12 @@ class TryOptionSyntax(object):
                 results.extend(self.handle_alias(test, all_tests))
 
         # uniquify the results over the test names
-        results = {test['test']: test for test in results}.values()
+        results = list({test['test']: test for test in results}.values())
         return results
 
     def find_all_attribute_suffixes(self, graph, prefix):
         rv = set()
-        for t in graph.tasks.itervalues():
+        for t in graph.tasks.values():
             for a in t.attributes:
                 if a.startswith(prefix):
                     rv.add(a[len(prefix):])
diff --git a/taskcluster/taskgraph/util/attributes.py b/taskcluster/taskgraph/util/attributes.py
index b44a3364f1..8a37392d63 100644
--- a/taskcluster/taskgraph/util/attributes.py
+++ b/taskcluster/taskgraph/util/attributes.py
@@ -11,7 +11,7 @@ def attrmatch(attributes, **kwargs):
     must be in the set.  A callable is called with the attribute value.  If an
     attribute is specified as a keyword argument but not present in the
     attributes, the result is False."""
-    for kwkey, kwval in kwargs.iteritems():
+    for kwkey, kwval in kwargs.items():
         if kwkey not in attributes:
             return False
         attval = attributes[kwkey]
diff --git a/taskcluster/taskgraph/util/seta.py b/taskcluster/taskgraph/util/seta.py
index a0cd30675a..f18083790d 100644
--- a/taskcluster/taskgraph/util/seta.py
+++ b/taskcluster/taskgraph/util/seta.py
@@ -43,7 +43,7 @@ class SETA(object):
                              kwargs={'timeout': 5, 'headers': headers})
             task_list = json.loads(response.content).get('jobtypes', '')
             if len(task_list) > 0:
-                low_value_tasks = task_list.values()[0]
+                low_value_tasks = list(task_list.values())[0]
 
             # Bug 1315145, disable SETA for tier-1 platforms until backfill is implemented.
             low_value_tasks = [x for x in low_value_tasks if x.find('debug') == -1]
diff --git a/testing/docker/funsize-update-generator/scripts/funsize.py b/testing/docker/funsize-update-generator/scripts/funsize.py
index fd591817c1..3068de5b36 100755
--- a/testing/docker/funsize-update-generator/scripts/funsize.py
+++ b/testing/docker/funsize-update-generator/scripts/funsize.py
@@ -1,6 +1,6 @@
 #!/usr/bin/env python
 
-import ConfigParser
+import six.moves.configparser
 import argparse
 import functools
 import hashlib
@@ -83,7 +83,7 @@ def get_option(directory, filename, section, option):
     log.debug("Exctracting [%s]: %s from %s/**/%s", section, option, directory,
               filename)
     f = find_file(directory, filename)
-    config = ConfigParser.ConfigParser()
+    config = six.moves.configparser.ConfigParser()
     config.read(f)
     rv = config.get(section, option)
     log.debug("Found %s", rv)
diff --git a/testing/docker/recipes/tooltool.py b/testing/docker/recipes/tooltool.py
index 952f9a5a7f..ed75536800 100755
--- a/testing/docker/recipes/tooltool.py
+++ b/testing/docker/recipes/tooltool.py
@@ -22,8 +22,9 @@
 # in which the manifest file resides and it should be called
 # 'manifest.tt'
 
+from __future__ import print_function
 import hashlib
-import httplib
+import six.moves.http_client
 import json
 import logging
 import optparse
@@ -34,12 +35,13 @@ import tarfile
 import tempfile
 import threading
 import time
-import urllib2
-import urlparse
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
+import six.moves.urllib.parse
 import zipfile
 
 from subprocess import PIPE
 from subprocess import Popen
+import six
 
 __version__ = '1'
 
@@ -308,7 +310,7 @@ class Manifest(object):
             rv = json.dump(
                 self.file_records, output_file, indent=0, cls=FileRecordJSONEncoder,
                 separators=(',', ': '))
-            print >> output_file, ''
+            print('', file=output_file)
             return rv
 
     def dumps(self, fmt='json'):
@@ -367,9 +369,9 @@ def list_manifest(manifest_file):
         ))
         return False
     for f in manifest.file_records:
-        print "%s\t%s\t%s" % ("P" if f.present() else "-",
+        print("%s\t%s\t%s" % ("P" if f.present() else "-",
                               "V" if f.present() and f.validate() else "-",
-                              f.filename)
+                              f.filename))
     return True
 
 
@@ -460,7 +462,7 @@ def fetch_file(base_urls, file_record, grabchunk=1024 * 4, auth_file=None, regio
     fetched_path = None
     for base_url in base_urls:
         # Generate the URL for the file on the server side
-        url = urlparse.urljoin(base_url,
+        url = six.moves.urllib.parse.urljoin(base_url,
                                '%s/%s' % (file_record.algorithm, file_record.digest))
         if region is not None:
             url += '?region=' + region
@@ -469,9 +471,9 @@ def fetch_file(base_urls, file_record, grabchunk=1024 * 4, auth_file=None, regio
 
         # Well, the file doesn't exist locally.  Let's fetch it.
         try:
-            req = urllib2.Request(url)
+            req = six.moves.urllib.request.Request(url)
             _authorize(req, auth_file)
-            f = urllib2.urlopen(req)
+            f = six.moves.urllib.request.urlopen(req)
             log.debug("opened %s for reading" % url)
             with open(temp_path, 'wb') as out:
                 k = True
@@ -488,7 +490,7 @@ def fetch_file(base_urls, file_record, grabchunk=1024 * 4, auth_file=None, regio
                          (file_record.filename, base_url, temp_path))
                 fetched_path = temp_path
                 break
-        except (urllib2.URLError, urllib2.HTTPError, ValueError) as e:
+        except (six.moves.urllib.error.URLError, six.moves.urllib.error.HTTPError, ValueError) as e:
             log.info("...failed to fetch '%s' from %s" %
                      (file_record.filename, base_url))
             log.debug("%s" % e)
@@ -668,7 +670,7 @@ def fetch_files(manifest_file, base_urls, filenames=[], cache_folder=None,
                 try:
                     if not os.path.exists(cache_folder):
                         log.info("Creating cache in %s..." % cache_folder)
-                        os.makedirs(cache_folder, 0700)
+                        os.makedirs(cache_folder, 0o700)
                     shutil.copy(os.path.join(os.getcwd(), localfile.filename),
                                 os.path.join(cache_folder, localfile.digest))
                     log.info("Local cache %s updated with %s" % (cache_folder,
@@ -759,14 +761,14 @@ def _authorize(req, auth_file):
 
 
 def _send_batch(base_url, auth_file, batch, region):
-    url = urlparse.urljoin(base_url, 'upload')
+    url = six.moves.urllib.parse.urljoin(base_url, 'upload')
     if region is not None:
         url += "?region=" + region
-    req = urllib2.Request(url, json.dumps(batch), {'Content-Type': 'application/json'})
+    req = six.moves.urllib.request.Request(url, json.dumps(batch), {'Content-Type': 'application/json'})
     _authorize(req, auth_file)
     try:
-        resp = urllib2.urlopen(req)
-    except (urllib2.URLError, urllib2.HTTPError) as e:
+        resp = six.moves.urllib.request.urlopen(req)
+    except (six.moves.urllib.error.URLError, six.moves.urllib.error.HTTPError) as e:
         _log_api_error(e)
         return None
     return json.load(resp)['result']
@@ -774,8 +776,8 @@ def _send_batch(base_url, auth_file, batch, region):
 
 def _s3_upload(filename, file):
     # urllib2 does not support streaming, so we fall back to good old httplib
-    url = urlparse.urlparse(file['put_url'])
-    cls = httplib.HTTPSConnection if url.scheme == 'https' else httplib.HTTPConnection
+    url = six.moves.urllib.parse.urlparse(file['put_url'])
+    cls = six.moves.http_client.HTTPSConnection if url.scheme == 'https' else six.moves.http_client.HTTPConnection
     host, port = url.netloc.split(':') if ':' in url.netloc else (url.netloc, 443)
     port = int(port)
     conn = cls(host, port)
@@ -797,14 +799,14 @@ def _s3_upload(filename, file):
 
 
 def _notify_upload_complete(base_url, auth_file, file):
-    req = urllib2.Request(
-        urlparse.urljoin(
+    req = six.moves.urllib.request.Request(
+        six.moves.urllib.parse.urljoin(
             base_url,
             'upload/complete/%(algorithm)s/%(digest)s' % file))
     _authorize(req, auth_file)
     try:
-        urllib2.urlopen(req)
-    except urllib2.HTTPError as e:
+        six.moves.urllib.request.urlopen(req)
+    except six.moves.urllib.error.HTTPError as e:
         if e.code != 409:
             _log_api_error(e)
             return
@@ -855,7 +857,7 @@ def upload(manifest, message, base_urls, auth_file, region):
     # Upload the files, each in a thread.  This allows us to start all of the
     # uploads before any of the URLs expire.
     threads = {}
-    for filename, file in files.iteritems():
+    for filename, file in files.items():
         if 'put_url' in file:
             log.info("%s: starting upload" % (filename,))
             thd = threading.Thread(target=_s3_upload,
@@ -885,7 +887,7 @@ def upload(manifest, message, base_urls, auth_file, region):
     # notify the server that the uploads are completed.  If the notification
     # fails, we don't consider that an error (the server will notice
     # eventually)
-    for filename, file in files.iteritems():
+    for filename, file in files.items():
         if 'put_url' in file and file['upload_ok']:
             log.info("notifying server of upload completion for %s" % (filename,))
             _notify_upload_complete(base_urls[0], auth_file, file)
diff --git a/testing/docker/rust-build/repack_rust.py b/testing/docker/rust-build/repack_rust.py
index e0a5e89c5f..bad93db043 100644
--- a/testing/docker/rust-build/repack_rust.py
+++ b/testing/docker/rust-build/repack_rust.py
@@ -5,6 +5,7 @@ with the necessary tool and target support for the Firefox
 build environment.
 '''
 
+from __future__ import print_function
 import os.path
 import requests
 import subprocess
@@ -24,12 +25,12 @@ def fetch_file(url):
 def fetch(url):
   '''Download and verify a package url.'''
   base = os.path.basename(url)
-  print('Fetching %s...' % base)
+  print(('Fetching %s...' % base))
   fetch_file(url + '.asc')
   fetch_file(url)
   fetch_file(url + '.sha256')
   fetch_file(url + '.asc.sha256')
-  print('Verifying %s...' % base)
+  print(('Verifying %s...' % base))
   subprocess.check_call(['shasum', '-c', base + '.sha256'])
   subprocess.check_call(['shasum', '-c', base + '.asc.sha256'])
   subprocess.check_call(['gpg', '--verify', base + '.asc', base])
@@ -40,15 +41,15 @@ def fetch(url):
 
 def install(filename, target):
   '''Run a package's installer script against the given target directory.'''
-  print(' Unpacking %s...' % filename)
+  print((' Unpacking %s...' % filename))
   subprocess.check_call(['tar', 'xf', filename])
   basename = filename.split('.tar')[0]
-  print(' Installing %s...' % basename)
+  print((' Installing %s...' % basename))
   install_cmd = [os.path.join(basename, 'install.sh')]
   install_cmd += ['--prefix=' + os.path.abspath(target)]
   install_cmd += ['--disable-ldconfig']
   subprocess.check_call(install_cmd)
-  print(' Cleaning %s...' % basename)
+  print((' Cleaning %s...' % basename))
   subprocess.check_call(['rm', '-rf', basename])
 
 def package(manifest, pkg, target):
@@ -60,9 +61,9 @@ def package(manifest, pkg, target):
 
 def fetch_package(manifest, pkg, host):
   version, info = package(manifest, pkg, host)
-  print('%s %s\n  %s\n  %s' % (pkg, version, info['url'], info['hash']))
+  print(('%s %s\n  %s\n  %s' % (pkg, version, info['url'], info['hash'])))
   if not info['available']:
-    print('%s marked unavailable for %s' % (pkg, host))
+    print(('%s marked unavailable for %s' % (pkg, host)))
     raise AssertionError
   fetch(info['url'])
   return info
@@ -84,15 +85,15 @@ def tar_for_host(host):
   return tar_options, tar_ext
 
 def repack(host, targets, channel='stable', suffix=''):
-  print("Repacking rust for %s..." % host)
+  print(("Repacking rust for %s..." % host))
   url = 'https://static.rust-lang.org/dist/channel-rust-' + channel + '.toml'
   req = requests.get(url)
   req.raise_for_status()
   manifest = toml.loads(req.content)
   if manifest['manifest-version'] != '2':
-    print('ERROR: unrecognized manifest version %s.' % manifest['manifest-version'])
+    print(('ERROR: unrecognized manifest version %s.' % manifest['manifest-version']))
     return
-  print('Using manifest for rust %s as of %s.' % (channel, manifest['date']))
+  print(('Using manifest for rust %s as of %s.' % (channel, manifest['date'])))
   print('Fetching packages...')
   rustc = fetch_package(manifest, 'rustc', host)
   cargo = fetch_package(manifest, 'cargo', host)
@@ -109,13 +110,13 @@ def repack(host, targets, channel='stable', suffix=''):
   for std in stds:
     install(os.path.basename(std['url']), install_dir)
     pass
-  print('Tarring %s...' % tar_basename)
+  print(('Tarring %s...' % tar_basename))
   tar_options, tar_ext = tar_for_host(host)
   subprocess.check_call(['tar', tar_options, tar_basename + tar_ext, install_dir])
   subprocess.check_call(['rm', '-rf', install_dir])
 
 def repack_cargo(host, channel='nightly'):
-  print("Repacking cargo for %s..." % host)
+  print(("Repacking cargo for %s..." % host))
   # Cargo doesn't seem to have a .toml manifest.
   base_url = 'https://static.rust-lang.org/cargo-dist/'
   req = requests.get(os.path.join(base_url, 'channel-cargo-' + channel))
@@ -125,7 +126,7 @@ def repack_cargo(host, channel='nightly'):
       if line.find(host) != -1:
           file = line.strip()
   if not file:
-      print('No manifest entry for %s!' % host)
+      print(('No manifest entry for %s!' % host))
       return
   manifest = {
           'date': req.headers['Last-Modified'],
@@ -142,7 +143,7 @@ def repack_cargo(host, channel='nightly'):
               },
           },
   }
-  print('Using manifest for cargo %s.' % channel)
+  print(('Using manifest for cargo %s.' % channel))
   print('Fetching packages...')
   cargo = fetch_package(manifest, 'cargo', host)
   print('Installing packages...')
@@ -150,7 +151,7 @@ def repack_cargo(host, channel='nightly'):
   subprocess.check_call(['rm', '-rf', install_dir])
   install(os.path.basename(cargo['url']), install_dir)
   tar_basename = 'cargo-%s-repack' % host
-  print('Tarring %s...' % tar_basename)
+  print(('Tarring %s...' % tar_basename))
   tar_options, tar_ext = tar_for_host(host)
   subprocess.check_call(['tar', tar_options, tar_basename + tar_ext, install_dir])
   subprocess.check_call(['rm', '-rf', install_dir])
diff --git a/testing/docker/rust-build/tcbuild.py b/testing/docker/rust-build/tcbuild.py
index d55c6f3a75..cf76482858 100644
--- a/testing/docker/rust-build/tcbuild.py
+++ b/testing/docker/rust-build/tcbuild.py
@@ -35,7 +35,7 @@ def read_tc_auth(tc_auth_file):
 
 def fill_template_dict(d, keys):
     for key, val in d.items():
-        if isinstance(val, basestring) and '{' in val:
+        if isinstance(val, str) and '{' in val:
             d[key] = val.format(**keys)
         elif isinstance(val, dict):
             fill_template_dict(val, keys)
diff --git a/testing/gtest/rungtests.py b/testing/gtest/rungtests.py
index 4999086800..e60d8d1fd7 100644
--- a/testing/gtest/rungtests.py
+++ b/testing/gtest/rungtests.py
@@ -6,6 +6,7 @@
 
 from __future__ import with_statement
 
+from __future__ import print_function
 from optparse import OptionParser
 import os
 import sys
@@ -172,13 +173,13 @@ def main():
     parser = gtestOptions()
     options, args = parser.parse_args()
     if not args:
-        print >>sys.stderr, """Usage: %s <binary>""" % sys.argv[0]
+        print("""Usage: %s <binary>""" % sys.argv[0], file=sys.stderr)
         sys.exit(1)
     if not options.xre_path:
-        print >>sys.stderr, """Error: --xre-path is required"""
+        print("""Error: --xre-path is required""", file=sys.stderr)
         sys.exit(1)
     if not options.utility_path:
-        print >>sys.stderr, """Warning: --utility-path is required to process assertion stacks"""
+        print("""Warning: --utility-path is required to process assertion stacks""", file=sys.stderr)
 
     update_mozinfo()
     prog = os.path.abspath(args[0])
@@ -189,7 +190,7 @@ def main():
                                   options.cwd,
                                   symbols_path=options.symbols_path,
                                   utility_path=options.utility_path)
-    except Exception, e:
+    except Exception as e:
         log.error(str(e))
         result = False
     sys.exit(0 if result else 1)
diff --git a/testing/mach_commands.py b/testing/mach_commands.py
index a744b0c44f..37090bb728 100644
--- a/testing/mach_commands.py
+++ b/testing/mach_commands.py
@@ -482,13 +482,13 @@ class PushToTry(MachCommandBase):
         rv = defaultdict(list)
         for item in items:
             parsed = parse_arg(item)
-            for key, values in parsed.iteritems():
+            for key, values in parsed.items():
                 rv[key].extend(values)
 
         if not allow_subitems:
-            if not all(item == [] for item in rv.itervalues()):
+            if not all(item == [] for item in rv.values()):
                 raise ValueError("Unexpected subitems in argument")
-            return rv.keys()
+            return list(rv.keys())
         else:
             return rv
 
@@ -616,7 +616,7 @@ class PushToTry(MachCommandBase):
                 print("No saved configuration called %s found in autotry.ini" % kwargs["load"],
                       file=sys.stderr)
 
-            for key, value in kwargs.iteritems():
+            for key, value in kwargs.items():
                 if value in (None, []) and key in defaults:
                     kwargs[key] = defaults[key]
 
@@ -653,7 +653,7 @@ class PushToTry(MachCommandBase):
 
         if kwargs["verbose"] and paths_by_flavor:
             print('The following tests will be selected: ')
-            for flavor, paths in paths_by_flavor.iteritems():
+            for flavor, paths in paths_by_flavor.items():
                 print("%s: %s" % (flavor, ",".join(paths)))
 
         if kwargs["verbose"] or not kwargs["push"]:
diff --git a/testing/mochitest/mach_commands.py b/testing/mochitest/mach_commands.py
index a667c05488..51ca667d32 100644
--- a/testing/mochitest/mach_commands.py
+++ b/testing/mochitest/mach_commands.py
@@ -4,6 +4,7 @@
 
 from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 from argparse import Namespace
 from collections import defaultdict
 from itertools import chain
@@ -305,14 +306,14 @@ class MachCommands(MachCommandBase):
 
         flavors = None
         if flavor:
-            for fname, fobj in ALL_FLAVORS.iteritems():
+            for fname, fobj in ALL_FLAVORS.items():
                 if flavor in fobj['aliases']:
                     if buildapp not in fobj['enabled_apps']:
                         continue
                     flavors = [fname]
                     break
         else:
-            flavors = [f for f, v in ALL_FLAVORS.iteritems() if buildapp in v['enabled_apps']]
+            flavors = [f for f, v in ALL_FLAVORS.items() if buildapp in v['enabled_apps']]
 
         from mozbuild.controller.building import BuildDriver
         self._ensure_state_subdir_exists('.')
@@ -376,8 +377,8 @@ class MachCommands(MachCommandBase):
         if not suites:
             # Make it very clear why no tests were found
             if not unsupported:
-                print(TESTS_NOT_FOUND.format('\n'.join(
-                    sorted(list(test_paths or test_objects)))))
+                print((TESTS_NOT_FOUND.format('\n'.join(
+                    sorted(list(test_paths or test_objects))))))
                 return 1
 
             msg = []
@@ -393,8 +394,8 @@ class MachCommands(MachCommandBase):
                 else:
                     reason = 'excluded by the command line'
                 msg.append('    mochitest -f {} ({})'.format(name, reason))
-            print(SUPPORTED_TESTS_NOT_FOUND.format(
-                buildapp, '\n'.join(sorted(msg))))
+            print((SUPPORTED_TESTS_NOT_FOUND.format(
+                buildapp, '\n'.join(sorted(msg)))))
             return 1
 
         if buildapp == 'android':
@@ -410,7 +411,7 @@ class MachCommands(MachCommandBase):
             msg = fobj['aliases'][0]
             if subsuite:
                 msg = '{} with subsuite {}'.format(msg, subsuite)
-            print(NOW_RUNNING.format(msg))
+            print((NOW_RUNNING.format(msg)))
 
             harness_args = kwargs.copy()
             harness_args['subsuite'] = subsuite
